<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008 Joerg Weller <weller@flagbit.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


	// DEFAULT initialization of a module [BEGIN]
unset($MCONF);
require_once('conf.php');
require_once($BACK_PATH.'init.php');
require_once($BACK_PATH.'template.php');
$LANG->includeLLFile('EXT:fb_realurltweak/cm1/locallang.xml');
require_once(PATH_t3lib.'class.t3lib_scbase.php');
require_once '../lib/class.tx_fbrealurltweak_urlgen.php';
require_once(PATH_t3lib.'class.t3lib_pagetree.php');
	// ....(But no access check here...)
	// DEFAULT initialization of a module [END]



/**
 * fb_realurltweak module cm1
 *
 * @author	Joerg Weller <weller@flagbit.de>
 * @package	TYPO3
 * @subpackage	tx_fbrealurltweak
 */

class tx_fbrealurltweak_cm1 extends t3lib_SCbase {
	


	/**
	 * Main function of the module. Write the content to $this->content
	 *
	 * @return	[type]		...
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

			// Draw the header.
		$this->doc = t3lib_div::makeInstance('mediumDoc');
		$this->doc->backPath = $BACK_PATH;
		$this->doc->form = '<form action="" method="post">';

		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;
		if (($this->id && $access) || ($BE_USER->user['admin'] && !$this->id))	{
			if ($BE_USER->user['admin'] && !$this->id)	{
				$this->pageinfo = array(
						'title' => '[root-level]',
						'uid'   => 0,
						'pid'   => 0
				);
			}

			$headerSection = $this->doc->getHeader('pages',$this->pageinfo,$this->pageinfo['_thePath']).'<br />'
					.$LANG->sL('LLL:EXT:lang/locallang_core.xml:labels.path').': '.t3lib_div::fixed_lgd_pre($this->pageinfo['_thePath'], 50);

			$this->content.=$this->doc->startPage($LANG->getLL('title'));
			$this->content.=$this->doc->header($LANG->getLL('title'));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->section('',$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,'SET[function]',$this->MOD_SETTINGS['function'],$this->MOD_MENU['function'])));
			$this->content.=$this->doc->divider(5);


			// Render content:
			echo $this->content;
			$this->moduleContent();

		}
	}


	/**
	 * Modul main function for generation RealURL Cache
	 *
	 */
	function moduleContent()	{
		global $BE_USER, $LANG;
		
		// URL generation Class
		$urlgen = t3lib_div::makeInstance('tx_fbrealurltweak_urlgen');
		
		// init TS Conf
		$urlgen->modSharedTSconfig = t3lib_BEfunc::getModTSconfig($this->id, 'mod.SHARED');

		
		
		// Initialize starting point of page tree:
		$treeStartingPoint = $this->id;
		$treeStartingRecord = t3lib_BEfunc::getRecord('pages', $treeStartingPoint);
		
		// Initialize tree object:
		$tree = t3lib_div::makeInstance('t3lib_pageTree');
		$tree->init('AND '.$GLOBALS['BE_USER']->getPagePermsClause(1));
		
		// Creating top icon; the current page
		$HTML = t3lib_iconWorks::getIconImage('pages', $treeStartingRecord, $GLOBALS['BACK_PATH'],'align="top"');
		$tree->tree[] = array(
		    'row' => $treeStartingRecord,
		    'HTML'=>$HTML
		);
		
		// Create the tree from starting point:
		$tree->getTree($treeStartingPoint, 999, '');
		
		// set Counter
		$totalcount = $tree->tree;
		$actcount = 0;		
		
		// init Progressbar
		$this->showProgressBar($totalcount,$actcount,'');
		
		// init Languages
		$translatedLanguagesArr = $urlgen->getAvailableLanguages(0, false, true);
		
		// get Language Overlays
		$trans_overlay_set = $urlgen->getLangOverlayTreeItems();
		
		 // Table Headline
		echo  '<table border="0" cellspacing="1" cellpadding="0" width="100%">
		    <tr  bgcolor="#999999">
		        <td><b>'.$LANG->getLL('page').':</b></td>';
		
		foreach ($translatedLanguagesArr as $language) {

			// is not accessible, continue
			if (!$BE_USER->checkLanguageAccess($language['uid'])) continue;

			// Flagicon
			$style = isset ($language['flagIcon']) ? 'background-image: url('.$language['flagIcon'].'); background-repeat: no-repeat; padding-top: 0px; padding-left: 22px;' : '';
			
			// Headline Column
			echo '<td style="'.$style.'"><b>'.htmlspecialchars($language['title']).'</b></td>';
		}		       
		echo '</tr>';
		

		// Page progressing
		foreach($tree->tree as $data)    {
			
			$actcount++;
			
			if(!$data['row']['uid']) continue;
			
			// update Progressbar
			$this->showProgressBar($totalcount,$actcount, $LANG->getLL('generate_url_for').": ".$data['row']['title']);			
		
			echo '
			        <tr bgcolor="#cccccc">
			            <td nowrap="nowrap">'.$data['HTML'].htmlspecialchars($data['row']['title']).'</td>';
			
			// generate URL for each Language
			foreach ($translatedLanguagesArr as $language) {
				
				// reset Timelimit
				set_time_limit(0);
				
				// no generation for excluded Doctypes
				if(in_array($data['row']['doktype'],$urlgen->excludedDoktypes)){
					echo '<td title="'.$LANG->getLL('no_url_generation_possible').'" style="background-color:#ff0; text-align: center; font-weight: bold;">'.$LANG->getLL('skipped').'</td>';
					continue;
				}	

				// delete old RealURL records
				$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_realurl_pathcache', 'page_id=' . $data['row']['uid'].' && language_id='.$language['uid']);
				if(!$language['uid']){
					$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_realurl_urldecodecache', 'page_id=' . $data['row']['uid']);
					$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_realurl_urlencodecache', 'page_id=' . $data['row']['uid']);		
				}			
				
				// generate only when default language or language Overlay is aviable 
				if(!$language['uid'] or $trans_overlay_set[$data['row']['uid']][$language['uid']]){
			         
					// was URL generation successfull?
					if($urlgen->generate_page_url($data['row']['uid'],$language['uid'])){
						echo '<td title="'.$LANG->getLL('successfully_generated').'" style="background-color:#69a550; text-align: center; font-weight: bold;">'.$LANG->getLL('ok').'</td>';
					}else{
						echo '<td title="'.$LANG->getLL('an_error_occurred').'" style="background-color:#cb3352; text-align: center; font-weight: bold;">'.$LANG->getLL('error').'</td>';
					}
					
				}else{
					echo '<td title="'.$LANG->getLL('translation_not_aviable').'" style="text-align: center; font-weight: bold;">'.$LANG->getLL('n/a').'</td>';					
				}
				
			}
			
			echo '</tr>';
		}
		
		// complete Progressbar
		$this->showProgressBar($totalcount,$actcount, $LANG->getLL('url_generation_completed'));
		echo  '</table>';		
				
	}
		
	/**
	 * generates an Progressbar
	 *
	 * @param int $actnum current count
	 * @param int $totalnum total count
	 * @param string $mesg some Message
	 */
	function showProgressBar($actnum, $totalnum, $msg){
		global $LANG;
		
		if(!$this->progressbar_generated){
			echo '
			<br />
			<br />
			<p id="progress-message">
			        '.$LANG->getLL('progressbar_startmsg').'.
			</p>
			<br />
			<div style="width:100%; height:20px; border: 1px solid black;">
			        <div id="progress-bar" style="float: left; width: 0%; height: 20px; background-color:green;">&nbsp;</div>
			        <div id="transparent-bar" style="float: left; width: 100%; height: 20px; background-color:'.$this->doc->bgColor2.';">&nbsp;</div>
			</div><br /><br />';
			$this->progressbar_generated=true;	
		}	
		
	        $percentDone = intval (($totalnum / count($actnum)) * 100);
	        echo ('
	        <script>
	                document.getElementById("progress-bar").style.width = "'.$percentDone.'%";
	                document.getElementById("transparent-bar").style.width = "'.(100-$percentDone).'%";
	                document.getElementById("progress-message").firstChild.data="'.htmlspecialchars($msg).'...";
	        </script>
	        ');
	
	        flush();		
			
	}
	
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fb_realurltweak/cm1/index.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/fb_realurltweak/cm1/index.php']);
}




// Make instance:
$SOBE = t3lib_div::makeInstance('tx_fbrealurltweak_cm1');
$SOBE->init();


$SOBE->main();

?>